/*
 * Ubiquity REST API
 * Ubiquity provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Protocols #### Mainnet The following protocols are currently supported: * bitcoin * ethereum * polkadot * xrp * algorand * stellar * dogecoin * oasis * near * terra * litecoin * bitcoincash * solana  #### Testnet * bitcoin/testnet * ethereum/ropsten * dogecoin/testnet * litecoin/testnet * bitcoincash/testnet  #### Native Ubiquity provides native access to all Blockchain nodes it supports. To access native functionality, use the protocol without the v2 prefix * bitcoin/(mainnet | testnet) - [RPC Documentation](https://developer.bitcoin.org/reference/rpc/) * ethereum/(mainnet | ropsten) - [RPC Documentation](https://ethereum.org/en/developers/docs/apis/json-rpc/) * polkadot/mainnet - [Sidecar API Documentation](https://paritytech.github.io/substrate-api-sidecar/dist/) * polkadot/mainnet/http-rpc - [Polkadot RPC Documentation](https://polkadot.js.org/docs/substrate/rpc/) * algorand/mainnet - [Algod API Documentation](https://developer.algorand.org/docs/reference/rest-apis/algod/v1/) * stellar/mainnet - [Stellar Horizon API Documentation](https://developers.stellar.org/api) * dogecoin/(mainnet | testnet) - [Dogecoin API Documentaion](https://developer.bitcoin.org/reference/rpc/) * oasis/mainnet - [Oasis Rosetta Gateway Documentation](https://www.rosetta-api.org/docs/api_identifiers.html#network-identifier) * near/mainnet - [NEAR RPC Documentation](https://docs.near.org/docs/api/rpc) * terra/mainnet - [Terra RPC Documentation](https://docs.terra.money/docs/develop/how-to/endpoints.html) * litecoin/mainnet - [Litecoin RPC Documentation](https://litecoin.info/index.php/Litecoin_API) * bitcoincash/mainnet - [Bitcoin Cash RPC Documentation](https://docs.bitcoincashnode.org/doc/json-rpc/) * solana/mainnet - [Solana RPC Documentation](https://docs.solana.com/developing/clients/jsonrpc-api)  A full URL example: https://ubiquity.api.blockdaemon.com/bitcoin/mainnet  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available. 
 *
 * The version of the OpenAPI document: 2.0.0
 * Contact: support@blockdaemon.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.gitlab.blockdaemon.ubiquity.model;

import java.util.Objects;
import java.util.Arrays;
import java.util.Map;
import java.util.HashMap;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.gitlab.blockdaemon.ubiquity.model.Effect;
import com.gitlab.blockdaemon.ubiquity.model.Operation;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.HashMap;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import com.fasterxml.jackson.annotation.JsonIgnore;
import org.openapitools.jackson.nullable.JsonNullable;
import java.util.NoSuchElementException;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.gitlab.blockdaemon.ubiquity.invoker.JSON;


/**
 * Tx
 */
@JsonPropertyOrder({
  Tx.JSON_PROPERTY_ID,
  Tx.JSON_PROPERTY_SLIP44,
  Tx.JSON_PROPERTY_ADDRESSES,
  Tx.JSON_PROPERTY_ASSETS,
  Tx.JSON_PROPERTY_DATE,
  Tx.JSON_PROPERTY_HEIGHT,
  Tx.JSON_PROPERTY_BLOCK_ID,
  Tx.JSON_PROPERTY_STATUS,
  Tx.JSON_PROPERTY_TAGS,
  Tx.JSON_PROPERTY_OPERATIONS,
  Tx.JSON_PROPERTY_EFFECTS
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen")
public class Tx {
  public static final String JSON_PROPERTY_ID = "id";
  private String id;

  public static final String JSON_PROPERTY_SLIP44 = "slip44";
  private Integer slip44;

  public static final String JSON_PROPERTY_ADDRESSES = "addresses";
  private JsonNullable<Set<String>> addresses = JsonNullable.<Set<String>>undefined();

  public static final String JSON_PROPERTY_ASSETS = "assets";
  private JsonNullable<Set<String>> assets = JsonNullable.<Set<String>>undefined();

  public static final String JSON_PROPERTY_DATE = "date";
  private Long date;

  public static final String JSON_PROPERTY_HEIGHT = "height";
  private JsonNullable<Long> height = JsonNullable.<Long>undefined();

  public static final String JSON_PROPERTY_BLOCK_ID = "block_id";
  private JsonNullable<String> blockId = JsonNullable.<String>undefined();

  /**
   * Result status of the transaction.
   */
  public enum StatusEnum {
    COMPLETED("completed"),
    
    FAILED("failed");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StatusEnum fromValue(String value) {
      for (StatusEnum b : StatusEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_STATUS = "status";
  private StatusEnum status;

  public static final String JSON_PROPERTY_TAGS = "tags";
  private JsonNullable<Set<String>> tags = JsonNullable.<Set<String>>undefined();

  public static final String JSON_PROPERTY_OPERATIONS = "operations";
  private Map<String, Operation> operations = null;

  public static final String JSON_PROPERTY_EFFECTS = "effects";
  private Map<String, Effect> effects = null;


  public Tx id(String id) {
    this.id = id;
    return this;
  }

   /**
   * Unique transaction identifier
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "0xF00Fa860473130C1df10707223E66Cb4B839B165", value = "Unique transaction identifier")
  @JsonProperty(JSON_PROPERTY_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getId() {
    return id;
  }


  @JsonProperty(JSON_PROPERTY_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setId(String id) {
    this.id = id;
  }


  public Tx slip44(Integer slip44) {
    this.slip44 = slip44;
    return this;
  }

   /**
   * SLIP-44 coin ID
   * @return slip44
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "60", value = "SLIP-44 coin ID")
  @JsonProperty(JSON_PROPERTY_SLIP44)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Integer getSlip44() {
    return slip44;
  }


  @JsonProperty(JSON_PROPERTY_SLIP44)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setSlip44(Integer slip44) {
    this.slip44 = slip44;
  }


  public Tx addresses(Set<String> addresses) {
    this.addresses = JsonNullable.<Set<String>>of(addresses);
    return this;
  }

  public Tx addAddressesItem(String addressesItem) {
    if (this.addresses == null || !this.addresses.isPresent()) {
      this.addresses = JsonNullable.<Set<String>>of(new LinkedHashSet<>());
    }
    try {
      this.addresses.get().add(addressesItem);
    } catch (java.util.NoSuchElementException e) {
      // this can never happen, as we make sure above that the value is present
    }
    return this;
  }

   /**
   * List of involved addresses (excluding contracts)
   * @return addresses
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "List of involved addresses (excluding contracts)")
  @JsonIgnore

  public Set<String> getAddresses() {
        return addresses.orElse(null);
  }

  @JsonProperty(JSON_PROPERTY_ADDRESSES)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public JsonNullable<Set<String>> getAddresses_JsonNullable() {
    return addresses;
  }
  
  @JsonProperty(JSON_PROPERTY_ADDRESSES)
  public void setAddresses_JsonNullable(JsonNullable<Set<String>> addresses) {
    this.addresses = addresses;
  }

  public void setAddresses(Set<String> addresses) {
    this.addresses = JsonNullable.<Set<String>>of(addresses);
  }


  public Tx assets(Set<String> assets) {
    this.assets = JsonNullable.<Set<String>>of(assets);
    return this;
  }

  public Tx addAssetsItem(String assetsItem) {
    if (this.assets == null || !this.assets.isPresent()) {
      this.assets = JsonNullable.<Set<String>>of(new LinkedHashSet<>());
    }
    try {
      this.assets.get().add(assetsItem);
    } catch (java.util.NoSuchElementException e) {
      // this can never happen, as we make sure above that the value is present
    }
    return this;
  }

   /**
   * List of moved assets by asset path
   * @return assets
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "List of moved assets by asset path")
  @JsonIgnore

  public Set<String> getAssets() {
        return assets.orElse(null);
  }

  @JsonProperty(JSON_PROPERTY_ASSETS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public JsonNullable<Set<String>> getAssets_JsonNullable() {
    return assets;
  }
  
  @JsonProperty(JSON_PROPERTY_ASSETS)
  public void setAssets_JsonNullable(JsonNullable<Set<String>> assets) {
    this.assets = assets;
  }

  public void setAssets(Set<String> assets) {
    this.assets = JsonNullable.<Set<String>>of(assets);
  }


  public Tx date(Long date) {
    this.date = date;
    return this;
  }

   /**
   * Unix timestamp
   * @return date
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1571222657", value = "Unix timestamp")
  @JsonProperty(JSON_PROPERTY_DATE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Long getDate() {
    return date;
  }


  @JsonProperty(JSON_PROPERTY_DATE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setDate(Long date) {
    this.date = date;
  }


  public Tx height(Long height) {
    this.height = JsonNullable.<Long>of(height);
    return this;
  }

   /**
   * Number of block if mined, otherwise omitted.
   * @return height
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "198258", value = "Number of block if mined, otherwise omitted.")
  @JsonIgnore

  public Long getHeight() {
        return height.orElse(null);
  }

  @JsonProperty(JSON_PROPERTY_HEIGHT)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public JsonNullable<Long> getHeight_JsonNullable() {
    return height;
  }
  
  @JsonProperty(JSON_PROPERTY_HEIGHT)
  public void setHeight_JsonNullable(JsonNullable<Long> height) {
    this.height = height;
  }

  public void setHeight(Long height) {
    this.height = JsonNullable.<Long>of(height);
  }


  public Tx blockId(String blockId) {
    this.blockId = JsonNullable.<String>of(blockId);
    return this;
  }

   /**
   * ID of block if mined, otherwise omitted.
   * @return blockId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "0xaf2948aba2ed8cc7d5b7d4e4f4164a7c8819efc94d30aab3fce6904df68dbc07", value = "ID of block if mined, otherwise omitted.")
  @JsonIgnore

  public String getBlockId() {
        return blockId.orElse(null);
  }

  @JsonProperty(JSON_PROPERTY_BLOCK_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public JsonNullable<String> getBlockId_JsonNullable() {
    return blockId;
  }
  
  @JsonProperty(JSON_PROPERTY_BLOCK_ID)
  public void setBlockId_JsonNullable(JsonNullable<String> blockId) {
    this.blockId = blockId;
  }

  public void setBlockId(String blockId) {
    this.blockId = JsonNullable.<String>of(blockId);
  }


  public Tx status(StatusEnum status) {
    this.status = status;
    return this;
  }

   /**
   * Result status of the transaction.
   * @return status
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Result status of the transaction.")
  @JsonProperty(JSON_PROPERTY_STATUS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public StatusEnum getStatus() {
    return status;
  }


  @JsonProperty(JSON_PROPERTY_STATUS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setStatus(StatusEnum status) {
    this.status = status;
  }


  public Tx tags(Set<String> tags) {
    this.tags = JsonNullable.<Set<String>>of(tags);
    return this;
  }

  public Tx addTagsItem(String tagsItem) {
    if (this.tags == null || !this.tags.isPresent()) {
      this.tags = JsonNullable.<Set<String>>of(new LinkedHashSet<>());
    }
    try {
      this.tags.get().add(tagsItem);
    } catch (java.util.NoSuchElementException e) {
      // this can never happen, as we make sure above that the value is present
    }
    return this;
  }

   /**
   * List of tags for this transaction
   * @return tags
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "List of tags for this transaction")
  @JsonIgnore

  public Set<String> getTags() {
        return tags.orElse(null);
  }

  @JsonProperty(JSON_PROPERTY_TAGS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public JsonNullable<Set<String>> getTags_JsonNullable() {
    return tags;
  }
  
  @JsonProperty(JSON_PROPERTY_TAGS)
  public void setTags_JsonNullable(JsonNullable<Set<String>> tags) {
    this.tags = tags;
  }

  public void setTags(Set<String> tags) {
    this.tags = JsonNullable.<Set<String>>of(tags);
  }


  public Tx operations(Map<String, Operation> operations) {
    this.operations = operations;
    return this;
  }

  public Tx putOperationsItem(String key, Operation operationsItem) {
    if (this.operations == null) {
      this.operations = new HashMap<>();
    }
    this.operations.put(key, operationsItem);
    return this;
  }

   /**
   * Operations in this transaction (opaque keys).
   * @return operations
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Operations in this transaction (opaque keys).")
  @JsonProperty(JSON_PROPERTY_OPERATIONS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Map<String, Operation> getOperations() {
    return operations;
  }


  @JsonProperty(JSON_PROPERTY_OPERATIONS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setOperations(Map<String, Operation> operations) {
    this.operations = operations;
  }


  public Tx effects(Map<String, Effect> effects) {
    this.effects = effects;
    return this;
  }

  public Tx putEffectsItem(String key, Effect effectsItem) {
    if (this.effects == null) {
      this.effects = new HashMap<>();
    }
    this.effects.put(key, effectsItem);
    return this;
  }

   /**
   * Effects by address, if supported
   * @return effects
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "{\"3AQCdZ9MxkMoRG4SMRtkbK6fEtgRPGzSDy\":{\"balance_changes\":{\"bitcoin/native/btc\":{\"old\":\"500\",\"delta\":\"-300\",\"new\":\"200\"}}}}", value = "Effects by address, if supported")
  @JsonProperty(JSON_PROPERTY_EFFECTS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Map<String, Effect> getEffects() {
    return effects;
  }


  @JsonProperty(JSON_PROPERTY_EFFECTS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setEffects(Map<String, Effect> effects) {
    this.effects = effects;
  }


  /**
   * Return true if this tx object is equal to o.
   */
  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Tx tx = (Tx) o;
    return Objects.equals(this.id, tx.id) &&
        Objects.equals(this.slip44, tx.slip44) &&
        Objects.equals(this.addresses, tx.addresses) &&
        Objects.equals(this.assets, tx.assets) &&
        Objects.equals(this.date, tx.date) &&
        Objects.equals(this.height, tx.height) &&
        Objects.equals(this.blockId, tx.blockId) &&
        Objects.equals(this.status, tx.status) &&
        Objects.equals(this.tags, tx.tags) &&
        Objects.equals(this.operations, tx.operations) &&
        Objects.equals(this.effects, tx.effects);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, slip44, addresses, assets, date, height, blockId, status, tags, operations, effects);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Tx {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    slip44: ").append(toIndentedString(slip44)).append("\n");
    sb.append("    addresses: ").append(toIndentedString(addresses)).append("\n");
    sb.append("    assets: ").append(toIndentedString(assets)).append("\n");
    sb.append("    date: ").append(toIndentedString(date)).append("\n");
    sb.append("    height: ").append(toIndentedString(height)).append("\n");
    sb.append("    blockId: ").append(toIndentedString(blockId)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    operations: ").append(toIndentedString(operations)).append("\n");
    sb.append("    effects: ").append(toIndentedString(effects)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

